<template>
  <div>
    <CardsRow v-loading="loading">
      <Cards types="addAlbum" @click="modals.albums = !modals.albums" />
      <Cards
        v-for="(item, itemKey) in albums"
        :key="itemKey"
        :content="item"
        path="/profile/photography/albums/"
      />
    </CardsRow>
    <portal to="modal">
      <Modal v-model="modals.albums">
        <template slot="title">{{ $t('buttons.create_album') }}</template>
        <AddAlbum />
      </Modal>
    </portal>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  reactive,
  ref,
  computed
} from '@nuxtjs/composition-api'

import { useAlbumsSubscription } from '~/sdk/hooks'
import { AlbumFragment } from '~/sdk/types'
import { AppEvents } from '~/types'

import CardsRow from '@/components/ui/CardsRow.vue'
import Cards from '@/components/ui/Cards.vue'
import Modal from '@/components/ui/Modal.vue'
import AddAlbum from '@/components/modal/AddAlbum.vue'

export default defineComponent({
  name: 'AlbumsPage',
  components: {
    Modal,
    Cards,
    CardsRow,
    AddAlbum
  },
  setup(_, { root }) {
    const options = reactive({
      enabled: !!root.$accessor.connection.connectedAsUser
    })

    root.$on(
      AppEvents.ConnectedAsUser,
      (value: boolean) => (options.enabled = value)
    )

    const { onResult, loading } = useAlbumsSubscription(
      {
        userId: root.$accessor.auth.userId as string,
        limit: 20000,
        offset: 0
      },
      options
    )

    const albums = ref<AlbumFragment[]>([])

    onResult(result => {
      if (result?.data?.albums) {
        albums.value = result.data.albums
      }
    })

    const modals = ref({
      albums: false
    })

    return {
      loading,
      albums,
      modals
    }
  }
})
</script>
